/*
*****************************************************************************************************************************************************
Projet Centrale domotique DomoMaison 2017 pour carte Arduino Mega 2560 et carte Ethernet (W5100)
Version 1.60 du 31/03/2017
Copyright 2017 PRIN Jean-Luc
Ce programme fonctionne avec le protocole Websockets (HTML5).

-------------------------------------------------------Descriptif du programme ----------------------------------------------------------------------
Les fonctions de ce programme sont :
- Commandes des volets, portail d'entrée et portes de garages
- Téléinfo du compteur électrique avec suivi des consommations
- Affichage de données sur 48 heures sous forme de courbe avec "tracker".
- Alarme Intrusion avec gestion de 6 caméras et de capteurs infra-rouges et de détecteurs d'ouverture
- Envoi d'Email sur évènements.
- Commande de matériels électriques de type "fil pilote" avec programmateur multizones et gestion de l'EJP.
- Traitement automatique des actions liées aux "heures creuses" et "heures pleines" fournies par un compteur électrique.
A venir :
- Suivi de la consommation Eau et détection de fuites
- Simulateur de présence
- Alarme Incendie

-------------------------------------------------------Fonctionnalités uitlisées --------------------------------------------------------------------
- Utilise un afficheur LCD 4 bits 4x20 caractères
- Fait clignoter une LED
- Utilise une horloge RTC DS1307 qui est mise à jour par rapport à un serveur NTP lors d'un reset ou par période définie
- Les données d'enregistrement sont stockées sur carte SD
- Les données de base au fonctionnement de la centrale sont stockées sur EEPROM
- Les données peuvent être modifiées par le web
- Les ordre sont donnés par une interface graphique par le web
- Les états de sorties peuvent être visualisées par un navigateur web

 Les trames d'émission et de réception sont toujours sous la forme :
 STX
 identifiant carte
 séparateur
 type d'information
 séparateur
 rang dans le type d'information
 séparateur
 valeur
 séparateur
 ......
 ETX

 Exemples de trame émise:
    (ME05;PARAM;01;123456789012)
    (ME05;HCHCA;01;123456789)


Ce programme permet sur demande du client:
- de transmettre les informations horaires des 48 heures précédentes à la demande.
La réponse du serveur étant pour chaque heure précédente (ME01;HORAI;xx;yy;123456789;123456789;1234;1234)
avec dans l'ordre xx variant de 00 à 47 puis heure, consommation heures creuses, consommation heures pleines, température extérieure, température
intérieure

- de transmettre les informations journalières d'une année - mois sélectionnés, les informations journalières étant stockées dans la micro SDCard.
Le message de la demande du client étant:(ME01;JOU:2000 à 2099;01 à 12) avec les 2 derniers paramètres représentant année et mois.
La réponse du serveur étant pour chaque jour: (ME01;TRJ:2012-09-12;123456789;123456789;123456789;123456789;123456789;123456789;1234;1234;1234;1234)
avec dans l'ordre année-mois-jour consommation heures creuses, consommation heures pleines,index heures creuses, index heures pleines,
température extérieure mini,température extérieure maxi,température intérieure mini,température intérieure maxi
La fin de l'envoi des informations journalières du mois est faite par un message: (ME01:ENJ).
Une demande année-mois n'ayant pas de jour renseigné est faite par le message:(ME01:NFJ).
*/

/*  ATTENTION, ce programme est compilé avec l'IDE Arduino n° 1.0.5 et ne supporte pas les IDE ultérieurs
La librairie WebSocket ne fonctionne pas avec les versions ultérieures
*/

// ================================================================================================================================
// Définition du chemin des fichiers ino
// ================================================================================================================================

#define SKETCH_PATH D:\DomoMaison_2017

// ================================================================================================================================
// IMPORTANT NOTE: Ce programme ne fonctionne qu'avec une carte Arduino MEGA2560
// ================================================================================================================================


